# -*- coding: utf-8 -*-
from setuptools import setup

packages = \
['gbf_beautify_honors']

package_data = \
{'': ['*']}

install_requires = \
['click>=8.0.3,<9.0.0',
 'dataclasses-json>=0.5.7,<0.6.0',
 'ortools>=9.3.10497,<10.0.0',
 'tabulate>=0.8.9,<0.9.0',
 'types-setuptools>=57.4.14,<58.0.0',
 'types-tabulate>=0.8.8,<0.9.0',
 'wcwidth>=0.2.5,<0.3.0']

entry_points = \
{'console_scripts': ['gbf-beautify-honors = gbf_beautify_honors.main:main']}

setup_kwargs = {
    'name': 'gbf-beautify-honors',
    'version': '0.1.2',
    'description': 'A CLI tool to help you figure out how to beautify honors in the Guild War event.',
    'long_description': '# Granblue Fantasay - Beautify Honors\n\n![PyPI - Package Version](https://img.shields.io/pypi/v/gbf-beautify-honors)\n![PyPI - Python Version](https://img.shields.io/pypi/pyversions/gbf-beautify-honors)\n![PyPI - Status](https://img.shields.io/pypi/status/gbf-beautify-honors)\n![PyPI - License](https://img.shields.io/pypi/l/gbf-beautify-honors)\n\nA CLI tool to help you figure out how to beautify honors in the Guild War event. (古戦場の貢献度調整)\n\nRead this in other languages: [English](README.md), [中文](README.zh-tw.md).\n\n<!-- a hack for pypi homepage shoing assets/sample_result.png -->\n![sample_result](https://raw.githubusercontent.com/qq88976321/gbf-beautify-honors/master/assets/sample_result.png)\n\n## Table of contents\n<!--ts-->\n* [Granblue Fantasay - Beautify Honors](README.md#granblue-fantasay---beautify-honors)\n   * [Table of contents](README.md#table-of-contents)\n   * [Prerequisites](README.md#prerequisites)\n   * [System requirements](README.md#system-requirements)\n   * [How to install](README.md#how-to-install)\n   * [How to use](README.md#how-to-use)\n      * [Interactive mode example](README.md#interactive-mode-example)\n      * [Direct mode example](README.md#direct-mode-example)\n   * [Examples](README.md#examples)\n      * [Case 1: There is a solution](README.md#case-1-there-is-a-solution)\n      * [Case 2: There is no solution](README.md#case-2-there-is-no-solution)\n   * [How it works](README.md#how-it-works)\n   * [How to develop](README.md#how-to-develop)\n      * [Setup](README.md#setup)\n<!--te-->\n\n## Prerequisites\n\nPlease read at least one of these well-written tutorials to known how to get the exact honors.\n\n- [kamigame - 古戦場の貢献度調整のやり方](https://kamigame.jp/%E3%82%B0%E3%83%A9%E3%83%96%E3%83%AB/%E3%82%A4%E3%83%99%E3%83%B3%E3%83%88/%E6%B1%BA%E6%88%A6%EF%BC%81%E6%98%9F%E3%81%AE%E5%8F%A4%E6%88%A6%E5%A0%B4/%E8%B2%A2%E7%8C%AE%E5%BA%A6%E8%AA%BF%E6%95%B4.html)\n- [gbf.wiki - Beauty of Honor](https://gbf.wiki/User:Midokuni/Notepad/Beauty_of_Honor)\n- [巴哈姆特 - 古戰場修分大法(控分技巧)](https://forum.gamer.com.tw/C.php?bsn=25204&snA=11313)\n\n## System requirements\n\n- Python 3.7+\n\n## How to install\n\nIt is recommended to use [pipx](https://pypa.github.io/pipx/) to install this tool because the application will be installed into an isolated and clean environment.\n\n```sh\npipx install gbf-beautify-honors\n```\n\nHowever, you still can use pip to install this cli.\n\n```sh\npip install gbf-beautify-honors\n```\n\n## How to use\n\n1. Solo the NM Bosses until the difference between your current honors and expected honors is roughly greater than one million. An appropriate gap is a good start because there may be a greater chance of finding a good way to achieve the goal.\n2. Run the cli tool in interactive mode or direct mode. Help page is simply shown below:\n\n```sh\n$ gbf-beautify-honors --help\nUsage: gbf-beautify-honors [OPTIONS]\n\nOptions:\n  --current INTEGER   Your current honors  [required]\n  --expected INTEGER  Your expected honors  [required]\n  --config PATH       Custom config path\n  --help              Show this message and exit.\n```\n\n### Interactive mode example\n\n```sh\n$ gbf-beautify-honors\nYour current honors : 1398542611\nYour expected honors: 1400000000\nCustom config path []:\n```\n\n### Direct mode example\n\n```sh\ngbf-beautify-honors --current=1398542611 --expected=1400000000\n```\n\n## Examples\n\nNext, we will use some examples to explain how to use this tool, and how to adjust the configuration file.\n\n### Case 1: There is a solution\n\n```sh\n$ gbf-beautify-honors\nYour current honors : 1398542611\nYour expected honors: 1400000000\nCustom config path []:\n╒═══════════════════════════════════════╤═════════╤═════════════════╕\n│ Action                                │   Honor │   Optimal Times │\n╞═══════════════════════════════════════╪═════════╪═════════════════╡\n│ Eyeball VH (0 button)                 │    8000 │               1 │\n├───────────────────────────────────────┼─────────┼─────────────────┤\n│ Meat Beast VH (0 button)              │   21400 │               4 │\n├───────────────────────────────────────┼─────────┼─────────────────┤\n│ Meat Beast EX (0 button)              │   50578 │               3 │\n├───────────────────────────────────────┼─────────┼─────────────────┤\n│ Meat Beast EX+ (0 button)             │   80800 │              10 │\n├───────────────────────────────────────┼─────────┼─────────────────┤\n│ Meat Beast EX+ (1 summon)             │   80810 │               5 │\n├───────────────────────────────────────┼─────────┼─────────────────┤\n│ Join raid and only use Break Assassin │       1 │               5 │\n╘═══════════════════════════════════════╧═════════╧═════════════════╛\n```\n\nPlease note that there may be multiple solutions to the same input and there is currently no guarantee of consistent results. Another possibility is shown below:\n\n```sh\n$ gbf-beautify-honors\nYour current honors : 1398542611\nYour expected honors: 1400000000\nCustom config path []:\n╒═══════════════════════════════════════╤═════════╤═════════════════╕\n│ Action                                │   Honor │   Optimal Times │\n╞═══════════════════════════════════════╪═════════╪═════════════════╡\n│ Eyeball H (0 button)                  │    6000 │               3 │\n├───────────────────────────────────────┼─────────┼─────────────────┤\n│ Eyeball VH (0 button)                 │    8000 │               3 │\n├───────────────────────────────────────┼─────────┼─────────────────┤\n│ Meat Beast VH (0 button)              │   21400 │               1 │\n├───────────────────────────────────────┼─────────┼─────────────────┤\n│ Meat Beast EX (0 button)              │   50578 │               2 │\n├───────────────────────────────────────┼─────────┼─────────────────┤\n│ Meat Beast EX+ (0 button)             │   80800 │              13 │\n├───────────────────────────────────────┼─────────┼─────────────────┤\n│ Meat Beast EX+ (1 summon)             │   80810 │               3 │\n├───────────────────────────────────────┼─────────┼─────────────────┤\n│ Join raid and only use Break Assassin │       1 │               3 │\n╘═══════════════════════════════════════╧═════════╧═════════════════╛\n```\n\n### Case 2: There is no solution\n\nBasically, there is always a solution because we can join raid and only use Break Assassin to get exactly 1 honor.\nHowever, this is usually an unrealistic approach, so the default config makes some constraints on the maximum time on each type of battle. This leads to the fact that sometimes it is not possible to find a solution.\n\n```sh\n$ gbf-beautify-honors\nYour current honors : 1399999900\nYour expected honors: 1400000000\nCustom config path []:\nThere is no solution to achieve the expected honors. Please relax the constraints and try again.\n```\n\nTo solve this problem, we can use custom config to relax the constraints to find a solution.\n\n1. Download the example [config.json](example_configs/config.json).\n2. Modify the `max_accepatable_times` of the action "Join raid and only use Break Assassin" to `100`.\n3. Re-run the script with custom config.\n\n```sh\n$ gbf-beautify-honors\nYour current honors : 1399999900\nYour expected honors: 1400000000\nCustom config path []: config.json\n╒═══════════════════════════════════════╤═════════╤═════════════════╕\n│ Action                                │   Honor │   Optimal Times │\n╞═══════════════════════════════════════╪═════════╪═════════════════╡\n│ Join raid and only use Break Assassin │       1 │             100 │\n╘═══════════════════════════════════════╧═════════╧═════════════════╛\n```\n\nThe configuration is flexible and you can try to modify different values in it, re-run the script and see if there is a solution. You can also add self-defined action into the config.json as long as you know you can get the exact honor value from this action, e.g. you can add this object into the actions list,\n\n```json\n{\n    "name": "Some custom action for demo",\n    "honor": 11,\n    "max_accepatable_times": 10\n}\n```\n\nRe-run the script, it just works!\n\n```sh\n$ gbf-beautify-honors\nYour current honors : 1399999900\nYour expected honors: 1400000000\nCustom config path []: config.json\n╒═══════════════════════════════════════╤═════════╤═════════════════╕\n│ Action                                │   Honor │   Optimal Times │\n╞═══════════════════════════════════════╪═════════╪═════════════════╡\n│ Join raid and only use Break Assassin │       1 │               1 │\n├───────────────────────────────────────┼─────────┼─────────────────┤\n│ Some custom action for demo           │      11 │               9 │\n╘═══════════════════════════════════════╧═════════╧═════════════════╛\n```\n\n## How it works\n\nWe can formulate this problem as an integer programming problem and solve it using the [OR-Tools](https://developers.google.com/optimization)\n\nIs this case, we use an integer variable h<sub>i</sub> to represent the exact honor earned from battle `i` (`i` can be `Eyeball N`, `Meat Beast EX+`, ...).\nAnd use another integer variable n<sub>i</sub> to represent the number of battles we need to fight for the battle `i`.\n\nWe want to get exact honors with minimum number of battles (more efficient), so the corresponding integer programming problem is:\n\n<!-- Minimize\\ \\displaystyle\\sum_{i} n_i -->\n![formula](https://render.githubusercontent.com/render/math?math=Minimize%5C%20%5Cdisplaystyle%5Csum_%7Bi%7D%20n_i)\n\n<!-- Subject\\ to\\ \\displaystyle\\sum_{i} h_i\\times n_i -->\n![formula](https://render.githubusercontent.com/render/math?math=Subject%5C%20to%5C%20%5Cdisplaystyle%5Csum_%7Bi%7D%20h_i%5Ctimes%20n_i%20%3D%20expected%5C_honor)\n\nAdditionally, we can add additional constriants to the integer variable n<sub>i</sub> to limit the maximum number of each battle. e.g.,\n\n![formula](https://render.githubusercontent.com/render/math?math=0%E2%89%A4n_i%E2%89%A410)\n\n## How to develop\n\n### Setup\n\nUse `poetry` to setup dev environment.\n\n```sh\npoetry install\npoetry shell\n```\n\nUse `pre-commit` hook to check coding style.\n\n```sh\npre-commit install -t commit-msg -t pre-commit\n```\n',
    'author': 'qq88976321',
    'author_email': 'qq88976321@gmail.com',
    'maintainer': None,
    'maintainer_email': None,
    'url': 'https://github.com/qq88976321/gbf-beautify-honors',
    'packages': packages,
    'package_data': package_data,
    'install_requires': install_requires,
    'entry_points': entry_points,
    'python_requires': '>=3.7,<4.0',
}


setup(**setup_kwargs)
